"""LCM type definitions
This file automatically generated by lcm.
DO NOT MODIFY BY HAND!!!!
"""

try:
    import cStringIO.StringIO as BytesIO
except ImportError:
    from io import BytesIO
import struct

import bot_core.twist_t

import bot_core.force_torque_t

import bot_core.position_3d_t

class robot_state_t(object):
    __slots__ = ["utime", "pose", "twist", "num_joints", "joint_name", "joint_position", "joint_velocity", "joint_effort", "force_torque"]

    def __init__(self):
        self.utime = 0
        self.pose = bot_core.position_3d_t()
        self.twist = bot_core.twist_t()
        self.num_joints = 0
        self.joint_name = []
        self.joint_position = []
        self.joint_velocity = []
        self.joint_effort = []
        self.force_torque = bot_core.force_torque_t()

    def encode(self):
        buf = BytesIO()
        buf.write(robot_state_t._get_packed_fingerprint())
        self._encode_one(buf)
        return buf.getvalue()

    def _encode_one(self, buf):
        buf.write(struct.pack(">q", self.utime))
        assert self.pose._get_packed_fingerprint() == bot_core.position_3d_t._get_packed_fingerprint()
        self.pose._encode_one(buf)
        assert self.twist._get_packed_fingerprint() == bot_core.twist_t._get_packed_fingerprint()
        self.twist._encode_one(buf)
        buf.write(struct.pack(">h", self.num_joints))
        for i0 in range(self.num_joints):
            __joint_name_encoded = self.joint_name[i0].encode('utf-8')
            buf.write(struct.pack('>I', len(__joint_name_encoded)+1))
            buf.write(__joint_name_encoded)
            buf.write(b"\0")
        buf.write(struct.pack('>%df' % self.num_joints, *self.joint_position[:self.num_joints]))
        buf.write(struct.pack('>%df' % self.num_joints, *self.joint_velocity[:self.num_joints]))
        buf.write(struct.pack('>%df' % self.num_joints, *self.joint_effort[:self.num_joints]))
        assert self.force_torque._get_packed_fingerprint() == bot_core.force_torque_t._get_packed_fingerprint()
        self.force_torque._encode_one(buf)

    def decode(data):
        if hasattr(data, 'read'):
            buf = data
        else:
            buf = BytesIO(data)
        if buf.read(8) != robot_state_t._get_packed_fingerprint():
            raise ValueError("Decode error")
        return robot_state_t._decode_one(buf)
    decode = staticmethod(decode)

    def _decode_one(buf):
        self = robot_state_t()
        self.utime = struct.unpack(">q", buf.read(8))[0]
        self.pose = bot_core.position_3d_t._decode_one(buf)
        self.twist = bot_core.twist_t._decode_one(buf)
        self.num_joints = struct.unpack(">h", buf.read(2))[0]
        self.joint_name = []
        for i0 in range(self.num_joints):
            __joint_name_len = struct.unpack('>I', buf.read(4))[0]
            self.joint_name.append(buf.read(__joint_name_len)[:-1].decode('utf-8', 'replace'))
        self.joint_position = struct.unpack('>%df' % self.num_joints, buf.read(self.num_joints * 4))
        self.joint_velocity = struct.unpack('>%df' % self.num_joints, buf.read(self.num_joints * 4))
        self.joint_effort = struct.unpack('>%df' % self.num_joints, buf.read(self.num_joints * 4))
        self.force_torque = bot_core.force_torque_t._decode_one(buf)
        return self
    _decode_one = staticmethod(_decode_one)

    _hash = None
    def _get_hash_recursive(parents):
        if robot_state_t in parents: return 0
        newparents = parents + [robot_state_t]
        tmphash = (0xb1235f2940339eff+ bot_core.position_3d_t._get_hash_recursive(newparents)+ bot_core.twist_t._get_hash_recursive(newparents)+ bot_core.force_torque_t._get_hash_recursive(newparents)) & 0xffffffffffffffff
        tmphash  = (((tmphash<<1)&0xffffffffffffffff)  + (tmphash>>63)) & 0xffffffffffffffff
        return tmphash
    _get_hash_recursive = staticmethod(_get_hash_recursive)
    _packed_fingerprint = None

    def _get_packed_fingerprint():
        if robot_state_t._packed_fingerprint is None:
            robot_state_t._packed_fingerprint = struct.pack(">Q", robot_state_t._get_hash_recursive([]))
        return robot_state_t._packed_fingerprint
    _get_packed_fingerprint = staticmethod(_get_packed_fingerprint)

